stages:
  - test
  - build
  - docu

rq-pytests:
  stage: test
  image: ros:humble
  before_script:
   - git clone https://gitlab-ci-token:${CI_JOB_TOKEN}@mygit.th-deg.de/roboct/robo_quality/rq_interfaces
   - git clone https://gitlab-ci-token:${CI_JOB_TOKEN}@mygit.th-deg.de/roboct/robo_quality/rq_hardware
   - git clone https://gitlab-ci-token:${CI_JOB_TOKEN}@mygit.th-deg.de/roboct/robo_quality/rq_controller
   - git clone https://gitlab-ci-token:${CI_JOB_TOKEN}@mygit.th-deg.de/roboct/robo_quality/rq_ddetection
   - git clone https://gitlab-ci-token:${CI_JOB_TOKEN}@mygit.th-deg.de/roboct/robo_quality/rq_trajectory
   - git clone https://gitlab-ci-token:${CI_JOB_TOKEN}@mygit.th-deg.de/roboct/robo_quality/rq_reconstruction
   - rosdep install --from-paths . -y --ignore-src
   - colcon build --merge-install
   - sudo apt install --reinstall software-properties-common
   - sudo add-apt-repository universe
   - sudo apt-get update
   - sudo apt-get install python3-pip 
   - pip3 install pytest pytest-cov netCDF4

  script:
   - pytest ./rq_controller/tests/
   
   
build-ros:
  stage: build
  needs: [rq-pytests]
  script:
    - source ./install/setup.bash
  artifacts:
    when: always
    paths:
      - install


create-docu:
  stage: docu
  needs: [rq-pytests]
  before_script:
    - pip3 install pdoc3
    - source ./install/setup.bash
  script:
    - mkdir doc
    - pdoc3 --html rq_controller -o=./doc/rq_controller -c show_source_code=True
  artifacts:
    when: always
    paths:
      - doc
